<!DOCTYPE html>
<html>
<body>
<script>
//variables which are not declared with var,let or const then those are global variables.
b="hello";
var B = {
    b:"this",
    f1:function(){
    document.write("my name is " + this.b + "<br>"); //here this refers to object scope
    },
    f2: () => {
        document.write("my name is " + this.b + "<br>");//here this refers to global object
    },
};
B.f1();
B.f2();
//nested regular function
a="is";
function f3(){
    var a="llllllllll";//this a is a local variable
    document.write(this.a + "<br>");// here this refers to a global variable
    function f4(){
        document.write(this.a + "<br>");//here also this refers to a global variable
    }
    f4();
}
f3();
//In nested arrow functions also this refers to global variables only.
f5 = () => {
    c="pv";
    document.write(this.c + "<br>");
    f6 = () => {
        document.write(this.c + "<br>");
    }
    f6();
}
f5();
//Regular function(parent)-Arrow function(child):in both cases this refers to global variables only.
d="Welcome";
function f7(){
    document.write(this.d + "<br>");
    f8 = () => {
        document.write(this.d + "<br>");
    }
    f8();
}
f7();
//Arrow function(child)-Regular function(parent):in both cases this refers to global variables only.

f9 = () => {
    
    document.write(this.e + "<br>");
    function f10(){
        e="world";
        document.write(this.e + "<br>");
        
        }
        f10();
}
f9();
////session question:here also displaying global variables only.
b1="this";
let b12 = () =>{
    document.write(this.b1 + " arrow" + "<br>");
}
function f11(){
    b1="hiiii";
    function f12(){
        document.write(this.b1 + "<br>");
        b12();
    }
    f12();
}
f11();

</script>
</body>
</html>